#include <fgwin.h>

/* generate a random integer between 2 numbers */
#define IRAND(min,max) ((rand()%((max)-(min)+1))+(min))

#define MAX(x,y) ((x) > (y)) ? (x) : (y)
#define MIN(x,y) ((x) < (y)) ? (x) : (y)

#define LEFT  0
#define RIGHT 1

char *virtbuff1;
char *virtbuff2;
int storevb;
int workvb;

/************************ Windows coords **************************/
UINT cxClient, cyClient;

/***************  logical palette declarations *********************/
HPALETTE hpal;

typedef struct _sprite
{
   char far *bitmap;
   int width;
   int height;
   int xoffset;
   int yoffset;
} SPRITE;

SPRITE *mosquito[8];
SPRITE *mfall[4];
SPRITE *mturn[4];
SPRITE *mzap[4];

/* forward declarations */
struct OBJstruct;
typedef struct OBJstruct OBJ, far *OBJp;

/* pointer to object action function */
typedef void ACTION (OBJp objp);
typedef ACTION *ACTIONp; 

/* data structure for objects */
typedef struct OBJstruct 
{
  OBJp  next; 
  OBJp  prev; 
  int x;
  int y;
  int z;
  int xspeed;
  int max_xspeed;
  int yspeed;
  int direction;
  int frame;
  int xmin;
  int xmax;
  int ymin;
  int ymax;
  int prev_xmin;
  int prev_xmax;
  int prev_ymin;
  int prev_ymax;

  SPRITE far *image;
  ACTIONp action; 
  OBJp attached_sprite;
} OBJ;

OBJp top_node, bottom_node;

/* globals ***********************************************************/
int nbugs;
char lamp[17760];
char rail[33180];

char abort_string[128];

/* function declarations *********************************************/
int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow);
long WINAPI _export WndProc(HWND hwnd, UINT message,
                            UINT wParam, LONG lParam);
void animate(void);
void blit(void);
void bug_fall(OBJp objp);
void bug_go(OBJp objp);
void bug_turn(OBJp objp);
void bug_turned(OBJp objp);
void bug_zap(OBJp objp);
int  getseed(void);
void init_globals(void);
int  intersect_lamp(OBJp objp);
int  in_zap_range(OBJp objp);
int  irandom(int min, int max);
void kill_object(OBJp objp);
void load_bugs(void);
void new_bug(void);
void put_bug(OBJp objp);
void put_lamp(void);
void put_rail(void);
void repair_screen(OBJp objp);
